<template>
  <v-card outlined class="contact-card">
    <v-card-title class="text-center d-block px-0 ma-0 font-weight-medium py-1">
      <v-sheet tile color="accent" class="mb-2 my-0 py-2 white--text subtitle-2 text-capitalize">
        <b class="title">Looking for exclusive deals</b>
        <br>Contact Us
      </v-sheet>
    </v-card-title>
    <v-card-text>
      <p class="caption text-center pa-0 ma-0" style="word-wrap: break-word">
        <a class=" font-weight-medium primary--text text--darken-2" style="text-decoration: none" href="tel:+19725367963">
          <v-icon>{{ icons.mdiPhone }}</v-icon>

          (800) 891-2311
        </a><br>
        Tell the property you found their listing on FindYourNextApartment and get rewarded!
      </p>
      <v-form v-model="isValid" class="caption">
        <v-row dense>
          <v-col cols="12" md="6">
            <v-text-field v-model="form.firtName" dense outlined hide-details label="First Name*" />
          </v-col>
          <v-col cols="12" md="6">
            <v-text-field v-model="form.lastName" dense outlined hide-details label="Last Name*" />
          </v-col>
          <v-col cols="12" md="6">
            <v-text-field
              v-model="form.email"
              dense
              outlined
              hide-details
              type="email"
              label="Email*"
            />
          </v-col>
          <v-col cols="12" md="6">
            <v-text-field
              v-model="form.phone"
              dense
              outlined
              hide-details
              type="tel"
              label="Phone*"
            />
          </v-col>
          <v-col cols="12">
            <v-menu
              v-model="dateMenu"
              offset-y
              :close-on-content-click="false"
              transition="scale-transition"
              min-width="290px"
            >
              <template v-slot:activator="{ on, attrs }">
                <v-text-field
                  v-model="form.date"
                  dense
                  outlined
                  hide-details
                  v-bind="attrs"
                  label="Move in date"
                  readonly
                  v-on="on"
                />
              </template>
              <v-date-picker
                v-model="form.date"
                dense
                :min="new Date().toISOString()"
                color="accent lighten-1"
                @input="dateMenu = false"
              />
            </v-menu>
          </v-col>
          <v-col cols="12" md="6">
            <v-text-field v-model="form.city" dense outlined hide-details label="City" />
          </v-col>
          <v-col cols="12" md="6">
            <v-text-field v-model="form.preferred" dense outlined hide-details label="Prefered Area" />
          </v-col>
          <v-col cols="12" md="6">
            <v-select
              v-model="form.nBeds"
              dense
              outlined
              hide-details
              label="Bedrooms"
              :items="bedroomsList"
            />
          </v-col>
          <v-col cols="12" md="6">
            <v-select
              v-model="form.nBaths"
              dense
              outlined
              hide-details
              label="Bathrooms"
              :items="bathroomsList"
            />
          </v-col>
          <v-col cols="12" md="6">
            <v-select
              v-model="form.allowDog"
              dense
              outlined
              hide-details
              :items="['No pets', 'Dogs', 'Cats', 'Other']"
              label="Pets"
            />
          </v-col>
          <v-col cols="12" md="6">
            <v-select
              v-model="form.size"
              dense
              outlined
              hide-details
              label="Size"
              :items="sizeOpts"
            />
          </v-col>
          <v-col cols="12" md="6">
            <v-select
              v-model="form.budget[0]"
              dense
              outlined
              hide-details
              label="Min budget"
              :items="priceOpts.min"
            />
          </v-col>
          <v-col cols="12" md="6">
            <v-select
              v-model="form.budget[1]"
              dense
              outlined
              hide-details
              label="Max budget"
              :items="priceOpts.max"
            />
          </v-col>
          <v-col cols="12" md="6">
            <v-select
              v-model="form.howHeard"
              dense
              outlined
              hide-details
              label="How did you heard about us?"
              :items="sourceList"
            />
          </v-col>
          <v-col cols="12" md="6">
            <v-select
              v-model="form.awareOf"
              dense
              outlined
              hide-details
              :items="['Nothing', 'Felony Record', 'Eviction Record', 'Broken Leases', 'Foreclosures', 'Bankruptcies']"
              label="Anything we need to aware of"
            />
          </v-col>
          <v-col cols="12">
            <v-textarea v-model="form.comments" dense hide-details outlined label="Special requirements / Comments" />
          </v-col>
        </v-row>
      </v-form>
    </v-card-text>
    <v-card-actions class="flex-column py-0">
      <v-btn color="accent" :loading="sending" block depressed @click="send">
        Send
      </v-btn>
      <p class="caption text-center">
        By submitting this form, you agree Terms of Service and Privacy Policy.
      </p>
    </v-card-actions>
    <v-overlay :value="showSent" absolute opacity="0.3">
      <v-alert prominent type="success" class="display-1 px-5">
        Sent
      </v-alert>
    </v-overlay>
  </v-card>
</template>
<style>
.contact-card {
  border-color: var(--v-accent-base) !important;
}
</style>
<script>
import { mdiPhone } from '@mdi/js'

const priceOpts = Object.freeze({
  min: [
    { value: 500, text: '$500' },
    { value: 700, text: '$700' },
    { value: 900, text: '$900' },
    { value: 1100, text: '$1100' },
    { value: 1300, text: '$1300' },
    { value: 1500, text: '$1500' }
  ],
  max: [
    { value: 1100, text: '$1100' },
    { value: 1300, text: '$1300' },
    { value: 1500, text: '$1500' },
    { value: 1700, text: '$1700' },
    { value: 1900, text: '$1900' },
    { value: 2100, text: '$2100' }
  ]
})
const sizeOpts = Object.freeze([
  ...Array(16).fill(0).map((_, idx) => ({ value: 400 + idx * 100, text: (400 + idx * 100) + ' sqft' })),
  { value: 2000, text: '2000 sqft' },
  { value: 2500, text: '2500 sqft' },
  { value: 3000, text: '3000 sqft' },
  { value: 3500, text: '3500 sqft' },
  { value: 4000, text: '4000 sqft' },
  { value: 4500, text: '4500 sqft' },
  { value: 5000, text: '5000 sqft' }
])
const icons = Object.freeze({ mdiPhone })

export default {
  data: () => ({
    icons,
    isValid: false,
    sizeOpts,
    priceOpts,
    sending: false,
    dateMenu: false,
    showSent: false,
    form: {
      firstName: '',
      lastName: '',
      email: '',
      phone: '',
      date: null,
      city: '',
      preferred: '',
      nBeds: null,
      sending: false,
      nBaths: null,
      allowDogs: false,
      allowCats: false,
      howHeard: '',
      size: null,
      budget: [0, 0],
      awareOf: '',
      comments: ''
    },
    bedroomsList: [
      { value: 0, text: 'Studio' },
      { value: 1, text: '1' },
      { value: 2, text: '2' },
      { value: 3, text: '3' },
      { value: 4, text: '4' }
    ],
    bathroomsList: [
      { value: 1, text: '1' },
      { value: 2, text: '2' },
      { value: 3, text: '3' },
      { value: 4, text: '4' }
    ],
    sourceList: ['Google', 'Yahoo', 'Bing', 'Yelp', 'Facebook', 'Instagram',
      'Property Referral', 'Friend', 'Craiglist', 'Not sure']
  }),
  methods: {
    async send () {
      this.sending = true
      await this.$axios.post('/messages', {
        ...this.form,
        type: 'contact-form'
      })
      this.sending = false
      this.showSent = true
      setTimeout(() => {
        this.showSent = false
      }, 1500)
    }
  }
}
</script>
